# === 🦊 GitLab ===
# Recover: (initramfs) fsck /dev/mapper/vagrant--vg-root
# Update sudo apt-get update && sudo apt-get install gitlab-ee

load '../config.rb'

BOX_IMAGE = "bento/ubuntu-16.04"

Vagrant.configure("2") do |config|
  config.vm.box = BOX_IMAGE

  ENV['LC_ALL']="en_US.UTF-8"

  config.vm.synced_folder "./backups", "/home/backups", id:"backups"

  config.vm.define "#{GITLAB_NAME}" do |node| 

    #node.vm.network :forwarded_port, guest: 80, host: 8083
    node.vm.hostname = "#{GITLAB_NAME}"
    node.vm.network "public_network", ip:"#{GITLAB_PUB_IP}",  bridge: "en0: Wi-Fi (AirPort)"
    #node.vm.network "public_network", bridge: "en0: Wi-Fi (AirPort)"
    node.vm.network "private_network", ip: "#{GITLAB_IP}"

    node.vm.provider "virtualbox" do |vb|
      #vb.memory = 6144
      vb.memory = 5120
      #vb.memory = 4096
      #vb.memory = 3072
      #vb.memory = 2048
      vb.cpus = 2
      vb.name = "#{GITLAB_NAME}"
    end

    node.vm.provision :shell, inline: <<-SHELL
      echo "👋 setup"
      # download GitLab packages
      curl -s https://packages.gitlab.com/install/repositories/gitlab/gitlab-ee/script.deb.sh | sudo bash
      # install GitLab
      EXTERNAL_URL="http://#{GITLAB_DOMAIN}" apt-get install -y gitlab-ee

      gitlab-ctl reconfigure

      echo "Bye! 👋👋👋 go to http://#{GITLAB_DOMAIN}"
      echo "- Change the password of the root user"

      # Add entries to hosts file:
      echo "" >> /etc/hosts
      echo '#{GITLAB_IP} #{GITLAB_DOMAIN}' >> /etc/hosts
      echo '#{REGISTRY_IP} #{REGISTRY_DOMAIN}' >> /etc/hosts
      echo '#{K8S_SERVER_IP} #{K8S_SERVER_DOMAIN}' >> /etc/hosts 
      echo "" >> /etc/hosts
    SHELL

    # node.vm.provision :shell, path: "init.sh", run: "always", privileged: false

    # Run it like that: vagrant up --provision-with tools
    node.vm.provision "tools", type: "shell" , inline: <<-SHELL
      echo "--- TOOLS ---"
    SHELL

  end
  # end of GitLab setup

end